
/**
 *   EJB code generation templates that are common
 *   across packages.
 *
 */



//
//  local_interface_method
//  is used in both weblogic.ejb.container.ejbc
//              and weblogic.ejb.container.cmp.rdbms.codegen
//
@start rule: common_local_method
  @method_signature
  {
    java.lang.Throwable __ee = null;

    weblogic.ejb.container.internal.InvocationWrapper __wrap;
    weblogic.ejb.container.internal.MethodDescriptor __md = 
      @method_descriptor_prefix@method_sig;

    @local_preInvoke

    @declare_result

    boolean doTxRetry = false;

    do {

      @simple_beanimpl_interface_name __bean = (@simple_beanimpl_interface_name) __wrap.getBean();

      int __oldState = __bean.__WL_getMethodState();

      try {
        weblogic.ejb.container.internal.AllowedMethodsHelper.pushBean(__bean);
        __bean.__WL_setMethodState(WLEnterpriseBean.STATE_BUSINESS_METHOD);

        @result __bean.@perhapsJavaClassCommonMethodPrefix@method_name(
          @method_parameters_without_types);

        @checkExistsOnMethod
      } catch (java.lang.Throwable t) {
        __ee = t;
      }
      finally {
        __bean.__WL_setMethodState(__oldState);
        weblogic.ejb.container.internal.AllowedMethodsHelper.popBean();
      }


      try {
        // Here is where we try to commit if it's our TX
        @local_postInvokeTxRetry
      } catch (java.lang.Throwable t) {
        __ee = t;
        doTxRetry = false;    // do not attempt any Tx Retry if we encountered
                              // an exception while attempting postInvokeTxRetry
                              // instead go directly to postInvokeCleanup
      }
    } while (doTxRetry);


    // postInvokeCleanup must *always* be done
    // if preInvoke succeeded

    try {
      @local_postInvokeCleanup
    } catch (java.lang.Throwable e) {
      if (e instanceof javax.ejb.EJBException) {
        throw (javax.ejb.EJBException) e;
      } 
      @enum_exceptions
      else {
        throw new javax.ejb.EJBException("Unexpected exception in " +
          "@ejb_class_name.@method_name():" + EOL +	
          e.getMessage() + EOL +
          weblogic.utils.StackTraceUtils.throwable2StackTrace(e));
      } 
    }
    @return_result
  }

@end rule: common_local_method


















