@start rule: main
@packageDeclaration

import weblogic.logging.MessageLogger;
import weblogic.logging.Loggable;
 
/** 
 * Copyright (c) @year by BEA Systems, Inc. All Rights Reserved.
 * @exclude
 */
public class @className
{
private static final String LOCALIZER_CLASS = "@localizerClass";

static {
  @registerResettableLogMessages
}

@logMessages
}
@end rule: main

@start rule: logMessage
  /**
   * @logMessageDescription
   *
   * messageid:  @logMessageId
   * severity:   @logMessageSeverity
   */
  public static String @logMethodName(@logArguments) @logExceptions {
    Object [] args = { @logArgumentClasses };
    MessageLogger.log(
	"@logMessageId",
	args,
	LOCALIZER_CLASS);
    return "@logMessageId";
  }

@logMessageLoggableMethod

@end rule: logMessage

@start rule: logMessageLoggable
  public static Loggable @loggableMethodName(@logArguments)  {
    Object[] args = { @logArgumentClasses };
    return new Loggable("@logMessageId", args, LOCALIZER_CLASS);
  }

@end rule: logMessageLoggable
@start rule: getMessage
  /**
   * @logMessageDescription
   *
   * messageid:  @logMessageId
   * severity:   @logMessageSeverity
   */
  public static String @logMethodName(@logArguments) @logExceptions {
    Object [] args = { @logArgumentClasses };
    return new Loggable("@logMessageId", args).getMessage();	
  }

@logMessageLoggableMethod

@end rule: getMessage

@start rule: registerResettableLogMessage
  MessageLogger.registerMessageResetData("@logMessageId", @logMessageResetPeriod);
@end rule: registerResettableLogMessage

@start rule: resetLogMessage
  /**
   * @logMessageDescription
   *
   * messageid:  @logMessageId
   * severity:   @logMessageSeverity
   */
  public static void reset@logMethodName() {
    MessageLogger.resetLogMessage("@logMessageId");
  }
@end rule: resetLogMessage